#!/usr/bin/perl
use 5.6.0;
use strict;
use lib './lib';
#-------------------------------------------------------------------------------
use FCGI;
use Satsuki::Base ();
use Satsuki::Timer ();
#-------------------------------------------------------------------------------
# Satsuki system - Startup routine (for FastCGI)
#			Copyright (C)2005-2007 nabe@abk / E-mail:nabe@abk.nu
#-------------------------------------------------------------------------------
# Last Update : 2007/01/16

#--------------------------------------------------
# FastCGI メインループ
#--------------------------------------------------
my $request = FCGI::Request();
while($request->Accept() >= 0) {
	#--------------------------------------------------
	# 時間計測開始
	#--------------------------------------------------
	my $timer = Satsuki::Timer->new();
	$timer->start();
	#--------------------------------------------------
	# メイン
	#--------------------------------------------------
	my $ROBJ = Satsuki::Base->new();	# ルートオブジェクト生成
	$ROBJ->{Timer} = $timer;		# タイマーの保存

	#--------------------------------------------------
	# FastCGI向け リロードチェック
	#--------------------------------------------------
	$ROBJ->init_for_fastcgi($request, 'Satsuki::');

	#--------------------------------------------------
	# メイン
	#--------------------------------------------------
	eval { $ROBJ->start_up(); };
	if ($ROBJ->{FastCGI_LastRequest}) { last; }

	undef %$ROBJ;		# メモリリーク対策（必須）
}
